`

hdu 1298 T9(字典树+dfs)

阅读更多

 T9

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 674    Accepted Submission(s): 271

Problem Description
A while ago it was quite cumbersome to create a message for the Short Message Service (SMS) on a mobile phone. This was because you only have nine keys and the alphabet has more than nine letters, so most characters could only be entered by pressing one key several times. For example, if you wanted to type "hello" you had to press key 4 twice, key 3 twice, key 5 three times, again key 5 three times, and finally key 6 three times. This procedure is very tedious and keeps many people from using the Short Message Service.

This led manufacturers of mobile phones to try and find an easier way to enter text on a mobile phone. The solution they developed is called T9 text input. The "9" in the name means that you can enter almost arbitrary words with just nine keys and without pressing them more than once per character. The idea of the solution is that you simply start typing the keys without repetition, and the software uses a built-in dictionary to look for the "most probable" word matching the input. For example, to enter "hello" you simply press keys 4, 3, 5, 5, and 6 once. Of course, this could also be the input for the word "gdjjm", but since this is no sensible English word, it can safely be ignored. By ruling out all other "improbable" solutions and only taking proper English words into account, this method can speed up writing of short messages considerably. Of course, if the word is not in the dictionary (like a name) then it has to be typed in manually using key repetition again.


Figure 8: The Number-keys of a mobile phone.

More precisely, with every character typed, the phone will show the most probable combination of characters it has found up to that point. Let us assume that the phone knows about the words "idea" and "hello", with "idea" occurring more often. Pressing the keys 4, 3, 5, 5, and 6, one after the other, the phone offers you "i", "id", then switches to "hel", "hell", and finally shows "hello".

Write an implementation of the T9 text input which offers the most probable character combination after every keystroke. The probability of a character combination is defined to be the sum of the probabilities of all words in the dictionary that begin with this character combination. For example, if the dictionary contains three words "hell", "hello", and "hellfire", the probability of the character combination "hell" is the sum of the probabilities of these words. If some combinations have the same probability, your program is to select the first one in alphabetic order. The user should also be able to type the beginning of words. For example, if the word "hello" is in the dictionary, the user can also enter the word "he" by pressing the keys 4 and 3 even if this word is not listed in the dictionary.

 

 

Input
The first line contains the number of scenarios.

Each scenario begins with a line containing the number w of distinct words in the dictionary (0<=w<=1000). These words are given in the next w lines. (They are not guaranteed in ascending alphabetic order, although it's a dictionary.) Every line starts with the word which is a sequence of lowercase letters from the alphabet without whitespace, followed by a space and an integer p, 1<=p<=100, representing the probability of that word. No word will contain more than 100 letters.

Following the dictionary, there is a line containing a single integer m. Next follow m lines, each consisting of a sequence of at most 100 decimal digits 2-9, followed by a single 1 meaning "next word".

 

Output
The output for each scenario begins with a line containing "Scenario #i:", where i is the number of the scenario starting at 1.

For every number sequence s of the scenario, print one line for every keystroke stored in s, except for the 1 at the end. In this line, print the most probable word prefix defined by the probabilities in the dictionary and the T9 selection rules explained above. Whenever none of the words in the dictionary match the given number sequence, print "MANUALLY" instead of a prefix.

Terminate the output for every number sequence with a blank line, and print an additional blank line at the end of every scenario.

 

Sample Input
2 5 hell 3 hello 4 idea 8 next 8 super 3 2 435561 43321 7 another 5 contest 6 follow 3 give 13 integer 6 new 14 program 4 5 77647261 6391 4681 26684371 77771

 

Sample Output
Scenario #1: i id hel hell hello i id ide idea Scenario #2: p pr pro prog progr progra program n ne new g in int c co con cont anoth anothe another p pr MANUALLY MANUALLY
 
            题目大意:先给出你几个单词的按键频数,然后给出你输入的数字,按这些数字的输入来输出最高频数的单词,没有就输出MANUALLY。

           这题是一道很好的字典树,一个模拟手机输入法的算法,要用到深搜来解决输出哪个频数最多的单词。第一次写,写了很长时间,现在看回来,发现不过如此,链表不是很熟悉,要多写多练习才行啊!

链接:http://acm.hdu.edu.cn/showproblem.php?pid=1298

代码:

#include <iostream>
#include <stdio.h>
#include <cstring>
#include <string>
using namespace std;

char map[10][5];
char res[105], str[105];
int MAX;

void set()  //定义map[][]
{
    strcpy(map[0], "");
    strcpy(map[1], "");
    strcpy(map[2], "abc");
    strcpy(map[3], "def");
    strcpy(map[4], "ghi");
    strcpy(map[5], "jkl");
    strcpy(map[6], "mno");
    strcpy(map[7], "pqrs");
    strcpy(map[8], "tuv");
    strcpy(map[9], "wxyz");
}

struct node     //结点结构
{
    int val;            //频率
    char ch[105];       //字符
    node *next[26];     //链表
};

node *root, memory[100005];
int cnt;

node* create()
{
    node *p = &memory[cnt++];
	p->val = 0;
    int i;
    for(i = 0; i < 26; i++)
    {
        p->next[i] = NULL;
    }
    return p;
}

void insert(char *s, int val)
{
    node *p = root;
    char str[105];
    int i, k;
    for(i = 0; s[i]; i++)
    {
        k = s[i] - 'a';
        if(p->next[k] == NULL)
        {
            p->next[k] = create();
        }
        p = p->next[k];
        p->val += val;      //结点频率相加
        str[i] = s[i];
        str[i+1] = 0;
        strcpy(p->ch, str); //结点保存该点的字符串
    }
}

void dfs(node *p, int cur, int op)    //深搜字典树(结点,当前位置,目标)
{
    if(cur == op)   //当前位置 == 目标位置
    {
        if(p->val > MAX)    //找频率最大的那个字符串
        {
            strcpy(res, p->ch);
            MAX = p->val;
        }
        return;
    }
    int i, k, l, len;
    k = str[cur+1] - '0';       //char数字->int数字
    len = strlen(map[k]);       //map[k]为k键包含的字符
    for(i = 0; i < len; i++)
    {
        l = map[k][i] - 'a';    //将字符->整型
        if(p->next[l] == NULL) continue;    //若为空,continue
        else dfs(p->next[l], cur+1, op);    //否则,继续深搜
    }
}

int main()
{
    int i, t, n, m, val, len, zz = 1;
    char sh[105];
    set();
    scanf("%d", &t);
    while(t--)
    {
        memset(memory, NULL, sizeof(memory));
        cnt = 0;
        root = create();
        scanf("%d", &n);
        for(i = 0; i < n; i++)
        {
            scanf("%s %d", sh, &val);
            insert(sh, val);    //将字符串插入字典树中
        }
		printf("Scenario #%d:\n", zz++);
        scanf("%d", &m);
        while(m--)
        {
            scanf("%s", str);
            len = strlen(str);
            for(i = 0; str[i] != '1'; i++)
            {
                MAX = -1;
                dfs(root, -1, i);
                if(MAX != -1) printf("%s\n", res);
                else printf("MANUALLY\n");
            }
			if(m != 0) printf("\n");
        }
        printf("\n\n");
    }

    return 0;
}

 

 

 

        

  • 大小: 4.6 KB
2
10
分享到:
评论
2 楼 gzhu_101majia 2011-10-04  
  
1 楼 基德KID.1412 2011-10-04  
我特么顶上!!  

相关推荐

Global site tag (gtag.js) - Google Analytics